VTK: vtkAmoebaMinimizer Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkAmoebaMinimizer Class Reference

nonlinear optimization with a simplex More...

`#include <vtkAmoebaMinimizer.h>`

Inheritance diagram for vtkAmoebaMinimizer:
[legend]
Collaboration diagram for vtkAmoebaMinimizer:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkAmoebaMinimizer * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetFunction (void(*f)(void *), void *arg)
| Specify the function to be minimized. More...
void | SetFunctionArgDelete (void(*f)(void *))
| Set a function to call when a void* argument is being discarded. More...
const char * | GetParameterName (int i)
| For completeness, an unchecked method to get the name for particular parameter (the result will be nullptr if no name was set). More...
int | GetNumberOfParameters ()
| Get the number of parameters that have been set. More...
void | Initialize ()
| Initialize the minimizer. More...
virtual void | Minimize ()
| Iterate until the minimum is found to within the specified tolerance, or until the MaxIterations has been reached. More...
virtual int | Iterate ()
| Perform one iteration of minimization. More...
void | EvaluateFunction ()
| Evaluate the function. More...
void | SetParameterValue (const char *name, double value)
| Set the initial value for the specified parameter. More...
void | SetParameterValue (int i, double value)
| Set the initial value for the specified parameter. More...
void | SetParameterScale (const char *name, double scale)
| Set the scale to use when modifying a parameter, i.e. More...
double | GetParameterScale (const char *name)
| Set the scale to use when modifying a parameter, i.e. More...
void | SetParameterScale (int i, double scale)
| Set the scale to use when modifying a parameter, i.e. More...
double | GetParameterScale (int i)
| Set the scale to use when modifying a parameter, i.e. More...
double | GetParameterValue (const char *name)
| Get the value of a parameter at the current stage of the minimization. More...
double | GetParameterValue (int i)
| Get the value of a parameter at the current stage of the minimization. More...
virtual void | SetFunctionValue (double)
| Get the function value resulting from the minimization. More...
double | GetFunctionValue ()
| Get the function value resulting from the minimization. More...
virtual void | SetContractionRatio (double)
| Set the amoeba contraction ratio. More...
virtual double | GetContractionRatio ()
| Set the amoeba contraction ratio. More...
virtual void | SetExpansionRatio (double)
| Set the amoeba expansion ratio. More...
virtual double | GetExpansionRatio ()
| Set the amoeba expansion ratio. More...
virtual void | SetTolerance (double)
| Specify the value tolerance to aim for during the minimization. More...
virtual double | GetTolerance ()
| Specify the value tolerance to aim for during the minimization. More...
virtual void | SetParameterTolerance (double)
| Specify the parameter tolerance to aim for during the minimization. More...
virtual double | GetParameterTolerance ()
| Specify the parameter tolerance to aim for during the minimization. More...
virtual void | SetMaxIterations (int)
| Specify the maximum number of iterations to try before giving up. More...
virtual int | GetMaxIterations ()
| Specify the maximum number of iterations to try before giving up. More...
virtual int | GetIterations ()
| Return the number of iterations that have been performed. More...
virtual int | GetFunctionEvaluations ()
| Return the number of times that the function has been evaluated. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkAmoebaMinimizer * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAmoebaMinimizer * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkAmoebaMinimizer ()
| ~vtkAmoebaMinimizer () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
void(* | Function )(void *)
void(* | FunctionArgDelete )(void *)
void * | FunctionArg
int | NumberOfParameters
char ** | ParameterNames
double * | ParameterValues
double * | ParameterScales
double | FunctionValue
double | ContractionRatio
double | ExpansionRatio
double | Tolerance
double | ParameterTolerance
int | MaxIterations
int | Iterations
int | FunctionEvaluations
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

nonlinear optimization with a simplex

vtkAmoebaMinimizer will modify a set of parameters in order to find the minimum of a specified function. The method used is commonly known as the amoeba method, it constructs an n-dimensional simplex in parameter space (i.e. a tetrahedron if the number or parameters is 3) and moves the vertices around parameter space until a local minimum is found. The amoeba method is robust, reasonably efficient, but is not guaranteed to find the global minimum if several local minima exist.

Tests:
  vtkAmoebaMinimizer (Tests)

Definition at line 27 of file vtkAmoebaMinimizer.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkAmoebaMinimizer::Superclass

Definition at line 31 of file vtkAmoebaMinimizer.h.

## Constructor & Destructor Documentation

## ◆ vtkAmoebaMinimizer()

vtkAmoebaMinimizer::vtkAmoebaMinimizer | ( |  | ) |
| protected

## ◆ ~vtkAmoebaMinimizer()

vtkAmoebaMinimizer::~vtkAmoebaMinimizer | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkAmoebaMinimizer* vtkAmoebaMinimizer::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkAmoebaMinimizer::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkAmoebaMinimizer::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkAmoebaMinimizer* vtkAmoebaMinimizer::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkAmoebaMinimizer::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkAmoebaMinimizer* vtkAmoebaMinimizer::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkAmoebaMinimizer::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ SetFunction()

void vtkAmoebaMinimizer::SetFunction | ( | void(*)(void *) | f,
|  | void * | arg
| ) |  |

Specify the function to be minimized.

When this function is called, it must get the parameter values by calling GetParameterValue() for each parameter, and then must call SetFunctionValue() to tell the minimizer what the result of the function evaluation was. The number of function evaluations used for the minimization can be retrieved using GetFunctionEvaluations().

## ◆ SetFunctionArgDelete()

void vtkAmoebaMinimizer::SetFunctionArgDelete | ( | void(*)(void *) | f | ) |

Set a function to call when a void* argument is being discarded.

## ◆ SetParameterValue() [1/2]

void vtkAmoebaMinimizer::SetParameterValue | ( | const char * | name,
|  | double | value
| ) |  |

Set the initial value for the specified parameter.

Calling this function for any parameter will reset the Iterations and the FunctionEvaluations counts to zero. You must also use SetParameterScale() to specify the step size by which the parameter will be modified during the minimization. It is preferable to specify parameters by name, rather than by number.

## ◆ SetParameterValue() [2/2]

void vtkAmoebaMinimizer::SetParameterValue | ( | int | i,
|  | double | value
| ) |  |

Set the initial value for the specified parameter.

Calling this function for any parameter will reset the Iterations and the FunctionEvaluations counts to zero. You must also use SetParameterScale() to specify the step size by which the parameter will be modified during the minimization. It is preferable to specify parameters by name, rather than by number.

## ◆ SetParameterScale() [1/2]

void vtkAmoebaMinimizer::SetParameterScale | ( | const char * | name,
|  | double | scale
| ) |  |

Set the scale to use when modifying a parameter, i.e.

the initial amount by which the parameter will be modified during the search for the minimum. It is preferable to identify scalars by name rather than by number.

## ◆ GetParameterScale() [1/2]

double vtkAmoebaMinimizer::GetParameterScale | ( | const char * | name | ) |

Set the scale to use when modifying a parameter, i.e.

the initial amount by which the parameter will be modified during the search for the minimum. It is preferable to identify scalars by name rather than by number.

## ◆ SetParameterScale() [2/2]

void vtkAmoebaMinimizer::SetParameterScale | ( | int | i,
|  | double | scale
| ) |  |

Set the scale to use when modifying a parameter, i.e.

the initial amount by which the parameter will be modified during the search for the minimum. It is preferable to identify scalars by name rather than by number.

## ◆ GetParameterScale() [2/2]

double vtkAmoebaMinimizer::GetParameterScale | ( | int | i | ) |
| inline

Set the scale to use when modifying a parameter, i.e.

the initial amount by which the parameter will be modified during the search for the minimum. It is preferable to identify scalars by name rather than by number.

Definition at line 74 of file vtkAmoebaMinimizer.h.

## ◆ GetParameterValue() [1/2]

double vtkAmoebaMinimizer::GetParameterValue | ( | const char * | name | ) |

Get the value of a parameter at the current stage of the minimization.

Call this method within the function that you are minimizing in order to get the current parameter values. It is preferable to specify parameters by name rather than by index.

## ◆ GetParameterValue() [2/2]

double vtkAmoebaMinimizer::GetParameterValue | ( | int | i | ) |
| inline

Get the value of a parameter at the current stage of the minimization.

Call this method within the function that you are minimizing in order to get the current parameter values. It is preferable to specify parameters by name rather than by index.

Definition at line 85 of file vtkAmoebaMinimizer.h.

## ◆ GetParameterName()

const char* vtkAmoebaMinimizer::GetParameterName | ( | int | i | ) |
| inline

For completeness, an unchecked method to get the name for particular parameter (the result will be nullptr if no name was set).

Definition at line 92 of file vtkAmoebaMinimizer.h.

## ◆ GetNumberOfParameters()

int vtkAmoebaMinimizer::GetNumberOfParameters | ( |  | ) |
| inline

Get the number of parameters that have been set.

Definition at line 97 of file vtkAmoebaMinimizer.h.

## ◆ Initialize()

void vtkAmoebaMinimizer::Initialize | ( |  | ) |

Initialize the minimizer.

This will reset the number of parameters to zero so that the minimizer can be reused.

## ◆ Minimize()

virtual void vtkAmoebaMinimizer::Minimize | ( |  | ) |
| virtual

Iterate until the minimum is found to within the specified tolerance, or until the MaxIterations has been reached.

## ◆ Iterate()

virtual int vtkAmoebaMinimizer::Iterate | ( |  | ) |
| virtual

Perform one iteration of minimization.

Returns zero if the tolerance stopping criterion has been met.

## ◆ SetFunctionValue()

virtual void vtkAmoebaMinimizer::SetFunctionValue | ( | double |  | ) |
| virtual

Get the function value resulting from the minimization.

## ◆ GetFunctionValue()

double vtkAmoebaMinimizer::GetFunctionValue | ( |  | ) |
| inline

Get the function value resulting from the minimization.

Definition at line 122 of file vtkAmoebaMinimizer.h.

## ◆ SetContractionRatio()

virtual void vtkAmoebaMinimizer::SetContractionRatio | ( | double |  | ) |
| virtual

Set the amoeba contraction ratio.

The default value of 0.5 gives fast convergence, but larger values such as 0.6 or 0.7 provide greater stability.

## ◆ GetContractionRatio()

virtual double vtkAmoebaMinimizer::GetContractionRatio | ( |  | ) |
| virtual

Set the amoeba contraction ratio.

The default value of 0.5 gives fast convergence, but larger values such as 0.6 or 0.7 provide greater stability.

## ◆ SetExpansionRatio()

virtual void vtkAmoebaMinimizer::SetExpansionRatio | ( | double |  | ) |
| virtual

Set the amoeba expansion ratio.

The default value is 2.0, which provides rapid expansion. Values between 1.1 and 2.0 are valid.

## ◆ GetExpansionRatio()

virtual double vtkAmoebaMinimizer::GetExpansionRatio | ( |  | ) |
| virtual

Set the amoeba expansion ratio.

The default value is 2.0, which provides rapid expansion. Values between 1.1 and 2.0 are valid.

## ◆ SetTolerance()

virtual void vtkAmoebaMinimizer::SetTolerance | ( | double |  | ) |
| virtual

Specify the value tolerance to aim for during the minimization.

## ◆ GetTolerance()

virtual double vtkAmoebaMinimizer::GetTolerance | ( |  | ) |
| virtual

Specify the value tolerance to aim for during the minimization.

## ◆ SetParameterTolerance()

virtual void vtkAmoebaMinimizer::SetParameterTolerance | ( | double |  | ) |
| virtual

Specify the parameter tolerance to aim for during the minimization.

## ◆ GetParameterTolerance()

virtual double vtkAmoebaMinimizer::GetParameterTolerance | ( |  | ) |
| virtual

Specify the parameter tolerance to aim for during the minimization.

## ◆ SetMaxIterations()

virtual void vtkAmoebaMinimizer::SetMaxIterations | ( | int |  | ) |
| virtual

Specify the maximum number of iterations to try before giving up.

## ◆ GetMaxIterations()

virtual int vtkAmoebaMinimizer::GetMaxIterations | ( |  | ) |
| virtual

Specify the maximum number of iterations to try before giving up.

## ◆ GetIterations()

virtual int vtkAmoebaMinimizer::GetIterations | ( |  | ) |
| virtual

Return the number of iterations that have been performed.

This is not necessarily the same as the number of function evaluations.

## ◆ GetFunctionEvaluations()

virtual int vtkAmoebaMinimizer::GetFunctionEvaluations | ( |  | ) |
| virtual

Return the number of times that the function has been evaluated.

## ◆ EvaluateFunction()

void vtkAmoebaMinimizer::EvaluateFunction | ( |  | ) |

Evaluate the function.

This is usually called internally by the minimization code, but it is provided here as a public method.

## Member Data Documentation

## ◆ Function

void(* vtkAmoebaMinimizer::Function) (void *)
| protected

Definition at line 193 of file vtkAmoebaMinimizer.h.

## ◆ FunctionArgDelete

void(* vtkAmoebaMinimizer::FunctionArgDelete) (void *)
| protected

Definition at line 194 of file vtkAmoebaMinimizer.h.

## ◆ FunctionArg

void* vtkAmoebaMinimizer::FunctionArg
| protected

Definition at line 195 of file vtkAmoebaMinimizer.h.

## ◆ NumberOfParameters

int vtkAmoebaMinimizer::NumberOfParameters
| protected

Definition at line 197 of file vtkAmoebaMinimizer.h.

## ◆ ParameterNames

char** vtkAmoebaMinimizer::ParameterNames
| protected

Definition at line 198 of file vtkAmoebaMinimizer.h.

## ◆ ParameterValues

double* vtkAmoebaMinimizer::ParameterValues
| protected

Definition at line 199 of file vtkAmoebaMinimizer.h.

## ◆ ParameterScales

double* vtkAmoebaMinimizer::ParameterScales
| protected

Definition at line 200 of file vtkAmoebaMinimizer.h.

## ◆ FunctionValue

double vtkAmoebaMinimizer::FunctionValue
| protected

Definition at line 201 of file vtkAmoebaMinimizer.h.

## ◆ ContractionRatio

double vtkAmoebaMinimizer::ContractionRatio
| protected

Definition at line 203 of file vtkAmoebaMinimizer.h.

## ◆ ExpansionRatio

double vtkAmoebaMinimizer::ExpansionRatio
| protected

Definition at line 204 of file vtkAmoebaMinimizer.h.

## ◆ Tolerance

double vtkAmoebaMinimizer::Tolerance
| protected

Definition at line 206 of file vtkAmoebaMinimizer.h.

## ◆ ParameterTolerance

double vtkAmoebaMinimizer::ParameterTolerance
| protected

Definition at line 207 of file vtkAmoebaMinimizer.h.

## ◆ MaxIterations

int vtkAmoebaMinimizer::MaxIterations
| protected

Definition at line 208 of file vtkAmoebaMinimizer.h.

## ◆ Iterations

int vtkAmoebaMinimizer::Iterations
| protected

Definition at line 209 of file vtkAmoebaMinimizer.h.

## ◆ FunctionEvaluations

int vtkAmoebaMinimizer::FunctionEvaluations
| protected

Definition at line 210 of file vtkAmoebaMinimizer.h.

The documentation for this class was generated from the following file:

- Common/Math/vtkAmoebaMinimizer.h